<id>
COPPA Compliance for YaBB 2.6.11 Build 1611
</id>

<version>
0.4
</version>

<mod info>
Description
-----------
This Mod will allow you to check the age of users on registration and either enable COPPA Compliance or reject registration to users under 13 years old.

Installation
------------
1) Modify YaBB files using BoardMod or manually.
2) Upload modified files to your server in ASCII mode.
3) Upload Coppa.pm and Privacy.pm to Sources/Mods and privacy.policy to Languages/English in ASCII mode.

Files to edit
-------------
AdminIndex.pl
Admin/AdminEdit.pm
Admin/AdminSubList.pm
Admin/ManageTemplates.pm
Admin/ModList.pm
Admin/ModuleChecker.pm
Admin/NewSettings.pm
Admin/Settings_Main.pm
Languages/English/Admin.lng
Languages/English/Error.lng
Languages/English/GModPrivileges.lng
Languages/English/Main.lng
Languages/English/Profile.lng
Languages/English/Register.lng
Sources/Profile.pm
Sources/Register.pm
Sources/SubList.pm
Sources/Subs.pm
Templates/default/default.html

Version History
---------------
V0.1 - First release - 11th April 2012
0.2 updated for 2.6.1 24th Sept, 2014
0.3 updated for 2.6.1 build 1606 26th Nov, 2014
</mod info>

<author>
Derek Barnstorm
</author>

<homepage>
http://yabbforumsoftware.com
</homepage>

<edit file>
AdminIndex.pl
</edit file>

<search for>
        "modagreement|$admintxt{'a2_sub4'}|$admintxt{'a2_label4'}|",
</search for>

<add after>
        "privacy_policy|$admintxt{'privacy'}|$admintxt{'privacy_label'}|",
</add after>

<edit file>
Admin/AdminEdit.pm
</edit file>

<search for>
sub GmodSettings2 {
</search for>

<add before>
sub ModifyPolicy {
    is_admin_or_gmod();

    opendir LNGDIR, $langdir;
    my @lfilesanddirs = readdir LNGDIR;
    closedir LNGDIR;

    my $policylanguage = $FORM{'policylanguage'} || $INFO{'policylanguage'} || $lang;
    foreach my $fld (sort {lc($a) cmp lc($b)} @lfilesanddirs) {
        if (-d "$langdir/$fld" && $fld =~ m^\A[0-9a-zA-Z_\#\%\-\:\+\?\$\&\~\,\@/]+\Z^ && -e "$langdir/$fld/Main.lng") {
            if ($policylanguage eq $fld) { $drawnldirs .= qq~<option value="$fld" selected="selected">$fld</option>~; }
            else { $drawnldirs .= qq~<option value="$fld">$fld</option>~; }
        }
    }

    my ($privacy_policy, $line);
    fopen(POLICY, "$langdir/$policylanguage/privacy.policy");
    while ($line = <POLICY>) {
        $line =~ tr/[\r\n]//d;
        FromHTML($line);
        $privacy_policy .= qq~$line\n~;
    }
    fclose(POLICY);
    $yymain .= qq~
<div class="bordercolor rightboxdiv">
    <table class="border-space pad-cell">
        <tr>
             <th class="titlebg"" style="padding-left:1%">$admin_img{'xx'} <b>$admin_txt{'edit_policy'}</b></th>
        </tr><tr>
        <td class="windowbg2">
            <label for="policy">
                <p>$admin_txt{'edit_policy_1'}</p>
                <p>$admin_txt{'edit_policy_2'}</p>
                <ul>
                    <li>{forum_url} - $admin_txt{'forum_url'}</li>
                    <li>{forum_email} - $admin_txt{'355'}</li>
                    <li>{forum_name} - $admin_txt{'350'}</li>
                </ul>
           </label>
        </td>
    </tr><tr>
        <td class="windowbg2">
            <form action="$adminurl?action=privacy_policy" method="post" enctype="application/x-www-form-urlencoded">
                <select name="policylanguage" id="policylanguage" size="1">
                $drawnldirs
                </select>
                <input type="submit" value="$admin_txt{'462'}" class="button" />
            </form>
        </td>
    </tr><tr>
        <td class="windowbg2 center">
            <form action="$adminurl?action=privacy_policy2" method="post" enctype="application/x-www-form-urlencoded">
                <input type="hidden" name="destination" value="$INFO{'destination'}" />
                <input type="hidden" name="policylanguage" value="$policylanguage" />
                <textarea rows="35" cols="95" name="policy" id="policy" style="width:95%">$privacy_policy</textarea><br /><br />
            </td>
        </tr>
    </table>
</div>
<div class="bordercolor rightboxdiv">
    <table class="border-space pad-cell">
        <tr>
            <th class="titlebg">$admin_img{'prefimg'} $admin_txt{'10'}</th>
        </tr><tr>
             <td class="catbg center"><input type="submit" value="$admin_txt{'10'} $policylanguage" class="button" /></td>
        </tr>
        </form>
    </table>
</div>
~;
    $yytitle     = "$admin_txt{'edit_policy'}";
    $action_area = 'privacy_policy';
    AdminTemplate();
    return;
}

sub ModifyPolicy2 {
    is_admin_or_gmod();

    if ($FORM{'policylanguage'}) { $policylanguage = $FORM{'policylanguage'}; }
    else { $policylanguage = $lang; }
    $FORM{'policy'} =~ tr/\r//d;
    $FORM{'policy'} =~ s~\A\n+~~;
    $FORM{'policy'} =~ s~\n+\Z~~;
    fopen(POLICY, ">$langdir/$policylanguage/privacy.policy");
    print POLICY $FORM{'policy'};
    fclose(POLICY);

    $FORM{'policy'} =~ s/\n/<br \/>\n/g;

    $yySetLocation = $FORM{'destination'} ? qq~$adminurl?action=$FORM{'destination'}~ : qq~$adminurl?action=privacy_policy;policylanguage=$FORM{'policylanguage'}~;
    redirectexit();
    return;
}

</add before>

<search for>
'modagreement',"$FORM{'modagreement'}",
</search for>

<add after>
'privacy_policy',"$FORM{'privacy_policy'}",
</add after>

<search for>
modagreement2 => "$FORM{'modagreement'}",
</search for>

<add after>
privacy_policy2 => "$FORM{'privacy_policy'}",
</add after>

<edit file>
Admin/AdminSubList.pm
</edit file>

<search for>
1;
</search for>

<add before>
## Coppa Compliance Mod ##
$director{'privacy_policy'} = 'AdminEdit.pm&ModifyPolicy';
$director{'privacy_policy2'} = 'AdminEdit.pm&ModifyPolicy2';

</add before>

<edit file>
Admin/ManageTemplates.pm
</edit file>

<search for>
## End Mod Hook fulltemplate
</search for>

<add before>
    $fulltemplate =~ s/({|<)yabb footer_links(}|>)//gsm;
</add before>

<edit file>
Admin/ModList.pm
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
    $coppacompliance_mod = q~COPPA Compliance|Derek Barnstorm|This Mod will allow you to check the age of users on registration and either enable COPPA Compliance or reject registration to users under 13 years old.|0.4|12th Dec, 2014~;
    push @installed_mods, $coppacompliance_mod;

</add before>

<edit file>
Admin/ModuleChecker.pm
</edit file>

<search for>

foreach my $module ( @modules ) {
</search for>

<add before>
push @modules, 'Date::Calc';
</add before>

<edit file>
Admin/NewSettings.pm
</edit file>

<search for>
                                            # 2: ask for the birthday, input required
</search for>

<add after>
                                            # 3: Enable Coppa Compliance
                                            # 4: Reject registration if under 13 years old
</add after>

<search for>
1;
EOF
</search for>

<add before>
\$coppa_fax = "\Q$coppa_fax\E";             # Set the fax number for the COPPA compliance form
\$coppa_address = "\Q$coppa_address\E";     # Set the mailing address for the COPPA compliance form
\$age_cookie = "\Q$age_cookie\E";           # Set the cookie name for registration age restriction
\$show_policy = $show_policy;           # Set to 1 to show the privacy policy link in footer
\$show_agreement = $show_agreement;     # Set to 1 to show the user agreement link in footer
</add before>

<search for>
\$editAgeLimit = $editAgeLimit;             # Set a limit on the amount of times that member's can edit their birthdate
</search for>

<replace>
\$editAgeLimit = 1;             # Set a limit on the amount of times that member's can edit their birthdate (Coppa Compliance - 1 edit only)
</replace>

<edit file>
Admin/Settings_Main.pm
</edit file>

<search for>
$imtext =~ s~<br />~\n~gsm;
</search for>

<add after>
$coppa_address =~ s/<br \/>/\n/gsm;
</add after>

<search for>
        {
            header => $settings_txt{'showhide'},
        },
</search for>

<add after>
        {
            description => qq~<label for="show_policy">$admin_txt{'show_policy'}</label>~,
            input_html => qq~<input type="checkbox" name="show_policy" id="show_policy" value="1"${ischecked($show_policy)} />~,
            name => 'show_policy',
            validate => 'boolean',
        },
        {
            description => qq~<label for="show_agreement">$admin_txt{'show_agreement'}</label>~,
            input_html => qq~<input type="checkbox" name="show_agreement" id="show_agreement" value="1"${ischecked($show_agreement)} />~,
            name => 'show_agreement',
            validate => 'boolean',
        },
</add after>

<search for>
              <option value="2"${isselected($birthday_on_reg == 2)}>$register_txt{'773'}</option>
</search for>

<add after>
              <option value="3"${isselected($birthday_on_reg == 3)}>$register_txt{'774'}</option>
              <option value="4"${isselected($birthday_on_reg == 4)}>$register_txt{'775'}</option>
</add after>

<search for>
            name => 'birthday_on_reg',
            validate => 'number,null',
        },
</search for>

<add after>
        {
            description => qq~<label for="coppa_fax">$register_txt{'coppa_fax'}</label>~,
            input_html => qq~<input type="text" name="coppa_fax" id="coppa_fax" size="20" value="$coppa_fax" />~,
            name => 'coppa_fax',
            validate => 'text,null',
            depends_on => ['birthday_on_reg==3'],
        },
        {
            description => qq~<label for="coppa_address">$register_txt{'coppa_address'}</label>~,
            input_html => qq~<textarea name="coppa_address" id="coppa_address" cols="35" rows="5">$coppa_address</textarea>~,
            name => 'coppa_address',
            validate => 'fulltext,null',
            depends_on => ['birthday_on_reg==3'],
        },
        {
            description => qq~<label for="age_cookie">$register_txt{'age_cookie'}</label>~,
            input_html => qq~<input type="text" name="age_cookie" id="age_cookie" size="20" value="$age_cookie" />~,
            name => 'age_cookie',
            validate => 'text,null',
            depends_on => ['birthday_on_reg==3||', 'birthday_on_reg==4'],
        },
</add after>

<search for>
        {
            description => qq~<label for="edit_age_limit">$admin_txt{'edit_age_limit'}</label>~,
            input_html => qq~<input type="text" size="2" name="editAgeLimit" id="edit_age_limit" value="$editAgeLimit" />~,
            name => 'editAgeLimit',
            validate => 'number,null',
        },
</search for>

<replace>
## removed by Coppa Compliance ##
</replace>

<search for>
    my %settings = @_;
</search for>

<add after>

    if ($settings{'birthday_on_reg'} == 3 && (!$settings{'coppa_fax'} && !$settings{'coppa_address'})) {
        LoadLanguage('Error');
        admin_fatal_error('coppa_fields_missing');
    }

    $settings{'coppa_address'} =~ s/[\n\r]{1,2}/<br \/>/gsm;
</add after>

<edit file>
Languages/English/Admin.lng
</edit file>

<search for>
1;
</search for>

<add before>
## Coppa Compliance Mod ##
$admin_txt{'edit_policy'} = 'Edit Privacy Policy';
$admin_txt{'edit_policy_1'} = q~Here you can edit your forum privacy policy. It is important to note that this is just a template for your convenience, and should be edited as needed to reflect your own website, country's laws and forum settings.~;
$admin_txt{'edit_policy_2'} = 'HTML is allowed and you can use the following tags:';
$admin_txt{'show_policy'} = qq~Show link to Privacy Policy in footer?<br /><span class="small">Note that you will need to modify the privacy policy to reflect your own website: <a href="$adminurl?action=privacy_policy">Privacy Policy</a></span>~;
$admin_txt{'show_agreement'} = 'Show link to User Agreement in footer?';
$admin_txt{'forum_url'} = 'Forum URL';

$admintxt{'privacy'} = 'Privacy Policy';
$admintxt{'privacy_label'} = 'Edit Privacy Policy';

$modulecheck{'Date::Calc'} = q~'Used for age restrictions on registration.<br />This module is only needed if you enable Coppa Compliance or don't allow users under the age of 13 to register. Otherwise you do not need this module.~;
## End Coppa Compliance Mod ##

</add before>

<edit file>
Languages/English/Error.lng
</edit file>

<search for>
1;
</search for>

<add before>
## Coppa Compliance Mod ##
$error_txt{'coppa_fields_missing'} = 'You must enter a fax number or mailing address if COPPA Compliance is enabled.';
$error_txt{'dob_compliance'} = 'Sorry, you must be aged 13 years or above to register on this forum.';
## End Coppa Compliance Mod ##

</add before>

<edit file>
Languages/English/GModPrivileges.lng
</edit file>

<search for>
1;
</search for>

<add before>
## Coppa Compliance Mod ##
$gmodprivexpl_txt{'privacy_policy'} = 'Allow to edit Privacy Policy';

</add before>

<edit file>
Languages/English/Main.lng
</edit file>

<search for>
1;
</search for>

<add before>
## Coppa Compliance Mod ##
$maintxt{'policy'} = 'Privacy Policy';
$maintxt{'agreement'} = 'User Agreement';

</add before>

<edit file>
Languages/English/Register.lng
</edit file>

<search for>
1;
</search for>

<add before>
## Coppa Compliance Mod ##
$register_txt{'774'} = 'Ask for birthday and enable COPPA Compliance';
$register_txt{'775'} = 'Ask for birthday and don\'t allow registration if under 13 years old';
$register_txt{'coppa_fax'} = 'Enter your fax number here for the COPPA Compliance form to be sent to:<br /><span class="small">If you have COPPA Compliance selected above, you will need to either enter a fax number here or a mailing address below (or both).</span>';
$register_txt{'coppa_address'} = 'Enter your mailing address here for the COPPA Compliance form to be sent to:<br /><span class="small">If you have COPPA Compliance selected above, you will need to either enter a mailing address here or a fax number above (or both).</span>';
$register_txt{'age_cookie'} = q~Age Cookie Name:<br /><span class="small">If you enable COPPA Compliance or don't allow users to register who are under the age of 13, you can enter a cookie name here to set a cookie if users fail the age check. This will stop users from going back and changing their date of birth.</span>~;
$register_txt{'dob'} = 'Date of birth';
$register_txt{'dob_enter'} = 'Please enter your date of birth';
$register_txt{'dob_edit'} = 'Note that you cannot change your date of birth after it has been entered.';
$register_txt{'dob_hide'} = 'Check this box if you would like to hide your age and birthyear from public view.';
$register_txt{'continue'} = 'Continue Registration';
$register_txt{'birthday_ac'} = '(<label for="birthmonth">MM</label>/<label for="birthday">DD</label>/<label for="birthyear">YYYY</label>)';
$register_txt{'birthday_bc'} = '(<label for="birthday">DD</label>/<label for="birthmonth">MM</label>/<label for="birthyear">YYYY</label>)';

%coppa_txt = (
'coppa' => 'COPPA Compliance',
'coppa_form' => 'COPPA Compliance Form',
'fax' => 'Fax:',
'address' => 'Address:',
'header_1' => 'Instructions for the Parent or Legal Guardian',
'header_2' => 'Account Details',
'header_3' => 'Parent or Legal Guardian Details',
'header_4' => 'Agreement',
'header_info_1' => 'Please print this form, complete it and return it to us ',
'header_info_1a' => 'by using either the fax number or mailing address below.',
'header_info_1b' => 'by using the fax the number below.',
'header_info_1c' => 'by using the mailing address below.',
'header_info_2' => "These are the registration details for the child's account on $mbname.<br />Once we have received this form we will create the account and notify you at the email address privided here.",
'header_info_2a' => 'Note that the display name should be different from the username.',
'header_info_3' => 'Please fill in the required information and sign the form below.',
'header_info_4' => "By signing this form I confirm that I have read the website Privacy Policy ($scripturl?action=privacy) and I consent to $mbname collecting the necessary information for my child to participate in the community. I have reviewed the information my child has supplied and confirm that is is correct. I understand that the profile information can be changed by logging in with the username and password entered on this form and that I can ask for my child's information to be removed at any time.",
'username' => 'Username:',
'display_name' => 'Display name:',
'email' => 'Email Address:',
'parent_name' => 'Full Name:',
'parent_relation' => 'Relation to child:',
'parent_email' => 'Email Address:',
'parent_number' => 'Phone Number:',
'signature' => 'Signature:',
'date' => 'Date:',
'admin_note' => "Note to the $mbname Administrator: Please remember to create the user account with the above information on receiving this form and notify the user at the email address provided that their account is ready to use.",
'coppa_message_1' => qq~Sorry, in order to comply with <a href="http://www.coppa.org" target="_blank">COPPA (Children's Online Privacy Protection Act)</a>, users under the age of 13 must get permission off a parent or legal guardian before they can be registered on this forum. Please ask a parent or legal guardian to complete a copy of our <a href="$scripturl?action=coppa" target="_blank">COPPA Compliance Form</a> and return it to us. After receiving the form we will create your account for you and notify you by email at the email address provided when your account is ready to use.~,
'coppa_message_2' => 'Click here to print a copy our Coppa Compliance Form',
'coppa_message_3' => 'If you require further information, please contact the',
'coppa_message_4' => 'Thank you,',
'coppa_message_5' => "The $mbname Team",
'coppa_error'  => qq~Please ask a parent or legal guardian to complete a copy of our <a href="$scripturl?action=coppa" target="_blank">COPPA Compliance form</a> and return it to us.~,
'admin_email' => 'Forum Administrator',
'cancel' => 'Cancel',
);
## End Coppa Compliance Mod ##

</add before>

<edit file>
Sources/Profile.pm
</edit file>

<search for>
    $editAgeLimit ||= 0;
</search for>

<add after>
    if ( $birthday_on_reg == 3 || $birthday_on_reg == 4 ) {
        $editAgeLimit = 1;
    }
</add after>

<edit file>
Sources/Register.pm
</edit file>

<search for>
sub Register {
</search for>

<add before>
sub AgeCheck {

    use Date::Calc qw( Today leap_year Delta_Days );
    if ( $FORM{'birthday'} ) {
        $user_birth_year  = $FORM{'birthyear'};
        $user_birth_month = $FORM{'birthmonth'};
        $user_birth_day   = $FORM{'birthday'};
    }
    else {
        $user_birth_year  = $FORM{'birth_year'};
        $user_birth_month = $FORM{'birth_month'};
        $user_birth_day   = $FORM{'birth_day'};
    }

    $user_birth_month =~ s/\D//gsm;
    $user_birth_day   =~ s/\D//gsm;
    $user_birth_year  =~ s/\D//gsm;

    timetostring($date);

    fatal_error(q{},$register_txt{'error_birth_month'}) if length($user_birth_month) < 2 || $user_birth_month < 1 || $user_birth_month > 12;
    fatal_error(q{},$register_txt{'error_birth_day'}) if length($user_birth_day) < 2 || $user_birth_day < 1 || $user_birth_day > 31;
    fatal_error(q{},$register_txt{'error_birth_year'}) if length($user_birth_year) < 4;
    fatal_error(q{},$register_txt{'error_birth_year_real'}) if $user_birth_year < ($year - 120) || $user_birth_year > $year;

    ($this_year,$this_month,$this_day) = Today([$gmt]);

    if (($user_birth_day == 29) && ($user_birth_month == 2) && !leap_year($this_year)) { $user_birth_day--; }

    if ((($this_year - $user_birth_year) >  13) || ((($this_year - $user_birth_year) == 13) && (Delta_Days($this_year,$user_birth_month,$user_birth_day, $this_year,$this_month,$this_day) >= 0))) {
        return;
    } else {
        if ($age_cookie ne q{}) {
            $yySetCookies1 = write_cookie(
                -name    => $age_cookie,
                -value   => 'age-check',
                -expires => '+43200m');
        }
        if ($birthday_on_reg == 3) {
            $yytitle = qq~$register_txt{'97'} - $coppa_txt{'coppa'}~;
            $yynavigation = qq~&rsaquo; $register_txt{'97'} - $coppa_txt{'coppa'}~;
            $admin_email = enc_eMail($coppa_txt{'admin_email'},$webmaster_email,$coppa_txt{'coppa'},'');
            $yymain .= qq~
<table class="tabtitle">
    <tr>
        <td style="padding-left:1%; height:30px"><img src="$imagesdir/xx.gif" alt="" /> $coppa_txt{'coppa'}</td>
    </tr>
</table>
<table class="cs_thin pad_4px">
    <tr>
        <td class="windowbg">
            <p>$coppa_txt{'coppa_message_1'}</p>
            <p><a style="font-weight: bold;" href="$scripturl?action=coppa" target=_blank">$coppa_txt{'coppa_message_2'}</a></p>
            <p>$coppa_txt{'coppa_message_3'} $admin_email.</p>
            <p>$coppa_txt{'coppa_message_4'}</p>
            <p>$coppa_txt{'coppa_message_5'}</p>
        </td>
    </tr><tr>
        <td class="catbg center">
            <input type="button" class="button" value="$coppa_txt{'cancel'}" onclick="location.href='$scripturl';" />
        </td>
    </tr>
</table>~;
            template();
            exit;
        }
        elsif ($birthday_on_reg == 4) {
            $yynavigation = qq~&rsaquo; $register_txt{'97'}~;
            fatal_error('dob_compliance');
        }
    }
}

</add before>

<search for>
    if ( $RegAgree == 1 && $FORM{'regnoagree'} ) {
        $yySetLocation = qq~$scripturl~;
        redirectexit();
    }
    if ( $RegAgree == 1 && !$FORM{'regagree'} ) {
        $yytitle      = qq~$register_txt{'97'}~;
        $yynavigation = qq~&rsaquo; $register_txt{'97'}~;
        if ($language) {
            fopen( AGREE, "$langdir/$language/agreement.txt" );
        }
        else {
            fopen( AGREE, "$langdir/$lang/agreement.txt" );
        }
        @agreement = <AGREE>;
        fclose(AGREE);
        $fullagree = join q{}, @agreement;
        $fullagree =~ s/\n/<br \/>/gsm;
        $yymain .= $myregister_fullagree;
        $yymain =~ s/{yabb fullagree}/$fullagree/sm;
        template();
        exit;
    }
</search for>

<replace>
    if (!$iamguest) { fatal_error('no_registration_logged_in'); }
    if (($birthday_on_reg == 3 || $birthday_on_reg == 4) && $FORM{'dob_compliance'}) { AgeCheck(); }
    if ($FORM{'regnoagree'}) {
        $yySetLocation = qq~$scripturl~;
        redirectexit();
    }
    if ($age_cookie && $yyCookies{$age_cookie} eq 'age-check') {
        if ($birthday_on_reg == 3) { fatal_error('dob_compliance',$coppa_txt{'coppa_error'}); }
        elsif ($birthday_on_reg == 4) { fatal_error('dob_compliance'); }
    }
    if (($birthday_on_reg == 3 || $birthday_on_reg == 4) && !$FORM{'dob_compliance'} && (!$RegAgree || ($RegAgree && !$FORM{'regagree'}))) {
        $yytitle = qq~$register_txt{'97'} - $register_txt{'dob'}~;
        $yynavigation = qq~&rsaquo; $register_txt{'97'} - $register_txt{'dob'}~;
        timetostring($date);
        $edit_age_txt = q{};
        if ($editAgeLimit == 1) { $edit_age_txt = qq~<br />$register_txt{'dob_edit'}~; }
        $yymain .= qq~
<form action="$scripturl?action=register" method="post" name="birth_date" onsubmit="return CheckAgeFields();">
    <table class="tabtitle pad_4px" style="margin: 0 auto; width: 400px;">
        <tr>
            <td style="padding-left:1%; height:30px"><img src="$imagesdir/xx.gif" alt="" /> $register_txt{'dob'}</td>
        </tr><tr>
            <td class="windowbg vtop">~;
    if ($timeselected =~ /[145]/) {
        $age_focus = qq~document.birth_date.birth_month.focus();~;
        $yymain .= qq~
                <label for="birth_month"><b>$register_txt{'dob_enter'}:</b></label>
            </td>
        </tr><tr>
            <td class="windowbg vtop">
                 <input type="text" name="birth_month" id="birth_month" size="2" maxlength="2" onkeypress="jumpatnext('document.birth_date.birth_month','document.birth_date.birth_day',2)" /> <input type="text" name="birth_day" id="birth_day" size="2" maxlength="2" onkeypress="jumpatnext('document.birth_date.birth_day','document.birth_date.birth_year',2)" /> <input type="text" name="birth_year" id="birth_year" size="4" maxlength="4" />~ . ($birthday_on_reg == 2 ? ' *' : '') . qq~ <span class="small">$register_txt{'birthday_a'}$edit_age_txt</span>
            </td>
        </tr>~;
    }
    else {
        $age_focus = qq~document.birth_date.birth_day.focus();~;
        $yymain .= qq~
                <label for="birth_day"><b>$register_txt{'dob_enter'}:</b></label>
            </td>
        </tr><tr>
            <td class="windowbg2 small vtop">
                <input type="text" name="birth_day" id="birth_day" size="2" maxlength="2" onkeypress="jumpatnext('document.birth_date.birth_day','document.birth_date.birth_month',2)" /> <input type="text" name="birth_month" id="birth_month" size="2" maxlength="2" onkeypress="jumpatnext('document.birth_date.birth_month','document.birth_date.birth_year',2)" /> <input type="text" name="birth_year" id="birth_year" size="4" maxlength="4" />~ . ($birthday_on_reg == 2 ? ' *' : '') . qq~ <span class="small">$register_txt{'birthday_b'}$edit_age_txt</span>
            </td>
        </tr>~;
    }
    if ($showage) {
        $yymain .= qq~<tr>
            <td class="windowbg small">
                <input type="checkbox" name="hide_age" id="hide_age" value="1" /> <label for="hide_age">$register_txt{'dob_hide'}</label>
            </td>
        </tr>~;
    }
    $yymain .= qq~<tr>
            <td class="catbg center">
                <input type="submit" value="$register_txt{'continue'}" name="dob_compliance" class="button" />
            </td>
        </tr>
    </table>
</form>
<script type="text/javascript">
    $age_focus

    function CheckAgeFields() {
        if ((document.birth_date.birth_day.value.length < 2 || document.birth_date.birth_day.value < 1 || document.birth_date.birth_day.value > 31 || /\\D/.test(document.birth_date.birth_day.value))) {
            alert("$register_txt{'error_birth_day'}");
            document.birth_date.birth_day.focus();
            return false;
        }
        if ((document.birth_date.birth_month.value.length < 2 || document.birth_date.birth_month.value < 1 || document.birth_date.birth_month.value > 12 || /\\D/.test(document.birth_date.birth_month.value))) {
            alert("$register_txt{'error_birth_month'}");
            document.birth_date.birth_month.focus();
            return false;
        }
        if ((document.birth_date.birth_year.value.length < 4 || /\\D/.test(document.birth_date.birth_year.value))) {
            alert("$register_txt{'error_birth_year'}");
            document.birth_date.birth_year.focus();
            return false;
        }
        if ((document.birth_date.birth_year.value < ($year - 120) || document.birth_date.birth_year.value > $year)) {
            alert("$register_txt{'error_birth_year_real'}");
            document.birth_date.birth_year.focus();
            return false;
        }
        return true;
    }

    function jumpatnext(from,to,length) {
        window.setTimeout('if (' + from + '.value.length == ' + length + ') ' + to + '.focus();', 1);
    }
</script>~;

    template();
    exit;
    }

    if ( $RegAgree == 1 && $FORM{'regnoagree'} ) {
        $yySetLocation = qq~$scripturl~;
        redirectexit();
    }
    if ( $RegAgree == 1 && !$FORM{'regagree'} ) {
        if (($birthday_on_reg == 3 || $birthday_on_reg == 4)) {
            $birthday_fields = qq~<input type="hidden" name="birth_day" id="birth_day" value="$FORM{'birth_day'}" />
      <input type="hidden" name="birth_month" id="birth_month" value="$FORM{'birth_month'}" />
      <input type="hidden" name="birth_year" id="birth_year" value="$FORM{'birth_year'}" />
      <input type="hidden" name="hide_age" id="hide_age" value="$FORM{'hide_age'}" />~;
        }
        else {
            $birthday_fields = q{};
        }
        $yytitle = qq~$register_txt{'97'} - $register_txt{'517'}~;
        $yynavigation = qq~&rsaquo; $register_txt{'97'} - $register_txt{'517'}~;
        if ($language) {
            fopen( AGREE, "$langdir/$language/agreement.txt" );
        }
        else {
            fopen( AGREE, "$langdir/$lang/agreement.txt" );
        }
        @agreement = <AGREE>;
        fclose(AGREE);
        $fullagree = join q{}, @agreement;
        $fullagree =~ s/\n/<br \/>/gsm;
        $yymain .= $myregister_fullagree;
        $yymain =~ s/{yabb fullagree}/$fullagree/sm;
        $yymain =~ s/{yabb dobreq}/$birthday_fields/sm;
        template();
        exit;
    }
</replace>

<search for>
    if ( $FORM{'reason'} )      { $reason         = $FORM{'reason'}; }
</search for>

<add after>
    if ( $FORM{'birthday'} )   { $birthdate[0]   = $FORM{'birthday'}; }
    if ( $FORM{'birthmonth'} ) { $birthdate[1]   = $FORM{'birthmonth'}; }
    if ( $FORM{'birthyear'} )  { $birthdate[2]   = $FORM{'birthyear'}; }
</add after>

<search for>
    if ( $FORM{'birth_year'} )  { $birthdate[2]   = $FORM{'birth_year'}; }
</search for>

<add after>
    if ( $FORM{'hide_age'} )    { $hideage        = $FORM{'hide_age'}; }
</add after>

<search for>
    if ( $RegAgree == 1 && $FORM{'regagree'} ) {
        $yymain .= q~
<input type="hidden" name="regagree" value="yes" />~;
</search for>

<replace>
    if ( $RegAgree == 1 && $FORM{'regagree'} ) {
        $yymain .= qq~
<input type="hidden" id="regagree" name="regagree" value="yes" />
<input type="hidden" id="birth_day" name="birth_day" value="$birthdate[0]" />
<input type="hidden" id="birth_month" name="birth_month" value="$birthdate[1]" />
<input type="hidden" id="birth_year" name="birth_year" value="$birthdate[2]" />
~;
</replace>

<search for>
        if ( $editAgeLimit == 1 ) {
            $editAgeTxt =
              qq~<br /><span class="small">$register_txt{'birthday_c'}</span>~;
        }
        timetostring($date);
        if ( $timeselected =~ /[145]/xsm ) {
            $yymain .=
                $myregister_bdonreg
              . ( $birthday_on_reg == 2 ? $myreg_req : q{} )
              . qq~ <span class="small">$register_txt{'birthday_a'}</span>~;
        }
        else {
            $yymain .=
                $myregister_bdonreg_2
              . ( $birthday_on_reg == 2 ? $myreg_req : q{} )
              . qq~ <span class="small">$register_txt{'birthday_b'}</span>~;
        }
</search for>

<replace>
        if ( $editAgeLimit == 1 || $birthday_on_reg == 3 || $birthday_on_reg == 4 ) {
            $editAgeTxt =
              qq~<br /><span class="small">$register_txt{'birthday_c'}</span>~;
        }
        timetostring($date);
        $bd_req = q{};
        $coppabd = q{};
        if ( $birthday_on_reg == 1 ){
            $bd_req = $myreg_req;
        }
        if ( $birthday_on_reg != 3 && $birthday_on_reg != 4 ) {
            if ( $timeselected =~ /[145]/xsm ) {
                $coppabd .=
                    $myregister_bdonreg
                    . ( $birthday_on_reg == 2 ? $myreg_req : q{} )
                    . qq~ <span class="small">$register_txt{'birthday_a'}</span> $bd_req~;
            }
            else {
                $coppabd .=
                    $myregister_bdonreg_2
                    . ( $birthday_on_reg == 2 ? $myreg_req : q{} )
                    . qq~ <span class="small">$register_txt{'birthday_b'}</span> $bd_req~;
            }
        }
        else {
            if ( $timeselected =~ /[145]/xsm ) {
                $coppabd .=
                    $myregister_bdonreg_coppa
                    . ( $birthday_on_reg == 2 ? $myreg_req : q{} )
                    . qq~ <span class="small">$register_txt{'birthday_ac'}</span>~;
            }
            else {
                $coppabd .=
                    $myregister_bdonreg_coppa_2
                    . ( $birthday_on_reg == 2 ? $myreg_req : q{} )
                    . qq~ <span class="small">$register_txt{'birthday_bc'}</span>~;
            }
        }
        $yymain .= $coppabd;
        $yymain =~ s/{yabb hide_age}/$hideage/sm;
</replace>

<search for>
        $member{'birth_month'} =~ s/\D//gxsm;
</search for>

<add before>
        if ( $member{'birthmonth'} ) { $member{'birth_month'} = $member{'birthmonth'}; }
        if ( $member{'birthday'} ) { $member{'birth_day'} = $member{'birthday'}; }
        if ( $member{'birthyear'} ) { $member{'birth_year'} = $member{'birthyear'}; }
</add before>

<search for>
        elsif ( $birthday_on_reg == 2 ) {
</search for>

<add before>
        elsif ( $birthday_on_reg == 3 || $birthday_on_reg == 4 ) {
            AgeCheck();
            ${ $uid . $reguser }{'bday'} =
"$member{'birth_month'}/$member{'birth_day'}/$member{'birth_year'}";
        }
</add before>

<search for>
    ${ $uid . $reguser }{'language'}   = $language;
</search for>

<add after>
    ${ $uid . $reguser }{'hideage'}    = $member{'hide_age'} ? 1 : 0;
</add after>

<edit file>
Sources/SubList.pm
</edit file>

<search for>
1;
</search for>

<add before>
## Coppa Compliance Mod ##
$director{'agreement'} = 'Mods/Privacy.pm&UserAgreement';
$director{'coppa'} = 'Mods/Coppa.pm&Coppa';
$director{'privacy'} = 'Mods/Privacy.pm&Policy';
</add before>

<edit file>
Sources/Subs.pm
</edit file>

<search for>
    $yygrayscript    = q{};
</search for>

<add after>

    $yyfooter_links = q{};
    if ($show_policy || $show_agreement) { $yyfooter_links .= q~<br />~; }
    if ($show_policy) { $yyfooter_links .= qq~<a href="$scripturl?action=privacy">$maintxt{'policy'}</a>~; }
    if ($show_policy && $show_agreement) { $yyfooter_links .= q~ | ~; }
    if ($show_agreement) { $yyfooter_links .= qq~<a href="$scripturl?action=agreement">$maintxt{'agreement'}</a>~; }
</add after>

<edit file>
Templates/default/default.html
</edit file>

<search for>
        {yabb copyright}<br />{yabb freespace}<br />
</search for>

<replace>
        {yabb copyright}<span class="small">{yabb footer_links}</span><br />{yabb freespace}<br />
</replace>

<edit file>
Templates/default/Register.template
</edit file>

<search for>
</form>~;

## agreement in registration form
</search for>

<add before>
{yabb dobreq}
</add before>

<search for>

$myregister_gender = qq~<tr>
</search for>

<add before>
$myregister_bdonreg_coppa = qq~<tr>
        <td class="windowbg right vtop">
            <label for="birthmonth"><b>$register_txt{'birthday'}:</b>{yabb editAgeTxt}</label>
        </td>
        <td class="windowbg2 vtop"><input type="text" name="birthmonth" id="birthmonth" size="2" value="{yabb birthdate1}" maxlength="2" disabled="disabled" /> <input type="text" name="birthday" id="birthday" size="2" value="{yabb birthdate0}" maxlength="2" disabled="disabled" /> <input type="text" name="birthyear" id="birthyear" size="4" value="{yabb birthdate2}" maxlength="4" disabled="disabled" /><input type="hidden" name="hide_age" id="hide_age" value="{yabb hide_age}" />~;

$myregister_bdonreg_coppa_2 = qq~<tr>
        <td class="windowbg right vtop">
            <label for="birth_day"><b>$register_txt{'birthday'}:</b>{yabb editAgeTxt}</label>
        </td>
        <td class="windowbg2 vtop"><input type="text" name="birthday" id="birthday" size="2" value="{yabb birthdate0}" maxlength="2" disabled="disabled" /> <input type="text" name="birthmonth" id="birthmonth" size="2" value="{yabb birthdate1}" maxlength="2" disabled="disabled" /> <input type="text" name="birthyear" id="birthyear" size="4" value="{yabb birthdate2}" maxlength="4" disabled="disabled" /><input type="hidden" name="hide_age" id="hide_age" value="{yabb hide_age}" />~;

</add before>