###############################################################################
# Privacy.pm                                                                  #
###############################################################################
# Coppa Compliance for YaBB 2.6.1                                             #
# Version 0.3                                                                 #
# Author: Derek Barnstorm                                                     #
# Updated to 2.6.1 by Deborah Rorabaugh (Dandello)                            #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 2.6.1                                                  #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2014 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# Software by:  The YaBB Development Team                                     #
#               with assistance from the YaBB community.                      #
###############################################################################

$privacypmver = 'YaBB 2.6.1 $Revision: 0.2 $';
if ($action eq 'detailedversion') { return 1; }

sub Policy {

    $forum_email = enc_eMail($webmaster_email,$webmaster_email,$maintxt{'policy'},'');

    if ($language) {
        fopen(POLICY, "$langdir/$language/privacy.policy");
    } else {
        fopen(POLICY, "$langdir/$lang/privacy.policy");
    }
    @privacy = <POLICY>;
    fclose(POLICY);
    $privacy_policy = join q{}, @privacy;
    $privacy_policy =~ s/\n/<br \/>/g;
    $privacy_policy =~ s~{forum_url}~$scripturl~g;
    $privacy_policy =~ s~{forum_email}~$forum_email~g;
    $privacy_policy =~ s~{forum_name}~$mbname~g;

    $yymain = qq~
    <table class="tabtitle pad_4px">
        <tr>
            <th style="padding-left:1%">$admin_img{'xx'} $maintxt{'policy'}</th>
        </tr>
    </table>
    <table class="bordercolor pad_4px cs_thin">
        <tr>
            <td class="windowbg">$privacy_policy</td>
        </tr>
    </table>~;

    $yytitle = $maintxt{'policy'};
    $yynavigation = qq~&rsaquo; $maintxt{'policy'}~;

    template();
    exit;

}

sub UserAgreement {

    if ($language) {
        fopen(AGREE, "$langdir/$language/agreement.txt");
    } else {
        fopen(AGREE, "$langdir/$lang/agreement.txt");
    }
    @agreement = <AGREE>;
    fclose(AGREE);
    $fullagree = join("", @agreement);
    $fullagree =~ s/\n/<br \/>/g;

    $yymain = qq~
    <table class="tabtitle pad_4px">
        <tr>
            <th style="padding-left:1%">$admin_img{'xx'} $maintxt{'agreement'}</th>
        </tr>
    </table>
    <table class="bordercolor pad_4px cs_thin">
        <tr>
            <td class="windowbg">$fullagree</td>
        </tr>
</table>~;

    $yytitle = $maintxt{'agreement'};
    $yynavigation = qq~&rsaquo; $maintxt{'agreement'}~;

    template();
    exit;
}

1;